;;;; Text modes.

;; word-wrap-mode: like visual-line-mode, but without the visual line part.

(define-minor-mode word-wrap-mode
  "Wrap lines at word boundaries."
  nil nil nil
  (cond (word-wrap-mode ;; enable
         (setq word-wrap t)
         (set (make-local-variable 'fringe-indicator-alist)
              (copy-alist fringe-indicator-alist))
         (rplacd (assoc 'continuation fringe-indicator-alist) nil)
         (message "Word-Wrap mode enabled"))
        (t ;;disable
         (setq word-wrap nil)
         (kill-local-variable 'fringe-indicator-alist)
         (message "Word-Wrap mode disabled"))))

(add-hook 'text-mode-hook 'word-wrap-mode)
