;; -*- lexical-binding: t; -*-

(setq vc-ignore-dir-regexp "")

(defun elmord-exwm-gen-workspace-output-plist (screeninfo)
  (let ((output (plist-get screeninfo :output))
        (workspaces (plist-get screeninfo :workspaces)))
    (cl-mapcan (lambda (ws) (list ws output)) workspaces)))

(defun elmord-exwm-set-workspace-font (screeninfo)
  (let ((frames (mapcar 'exwm-workspace--workspace-from-frame-or-index
                        (plist-get screeninfo :workspaces)))
        (font (plist-get screeninfo :font)))
    (set-frame-font font nil frames)))

(defvar elmord-exwm-monitor-setup
  '((:output "VGA-1" :workspaces (1 2 3 4 5) :font "Monospace-11")
    (:output "LVDS-1" :workspaces (6 7 8 9 0) :font "Monospace-11")))

(defun elmord-exwm-setup-monitors (&optional config)
  (when (not config)
    (setq config elmord-exwm-monitor-setup))
  (setq exwm-randr-workspace-output-plist
        (cl-mapcan #'elmord-exwm-gen-workspace-output-plist config))
  (mapc #'elmord-exwm-set-workspace-font config)
  (exwm-randr--refresh)
  (elmord-exwm-refresh-stalonetray))

(defun elmord-exwm-refresh-stalonetray ()
  (start-process
   "*stalonetray*" nil "sh" "-c"
   "killall stalonetray; exec stalonetray --window-layer top --geometry 1x1-0-0 --grow-gravity E"))

(add-hook 'exwm-randr-screen-change-hook 'elmord-exwm-setup-monitors)
(add-hook 'exwm-init-hook 'elmord-exwm-refresh-stalonetray)

;; (defun elmord-setup-vga-screen-font ()
;;   (interactive)
;;   (let ((frames
;;          (mapcar 'exwm-workspace--workspace-from-frame-or-index
;;                  '(1 2 3 4 5))))
;;     (set-frame-font "Monospace-10.5" nil frames)))

;; (add-hook 'exwm-manage-finish-hook 'elmord-setup-vga-screen-font)

(winner-mode)
;;(exwm-input-set-key (kbd "s-/") 'winner-undo)
;;(exwm-input-set-key (kbd "s-?") 'winner-redo)

(add-hook 'find-file-hook
  (defun elmord-find-file-hook-rename ()
    ;; (when (and (buffer-file-name)
    ;;            (string-prefix-p "/home/vitor/projects/" (buffer-file-name)))
    ;;   (rename-buffer (string-remove-prefix "/home/vitor/projects/" (buffer-file-name)) t))
    (setq mode-line-buffer-identification
          (append mode-line-buffer-identification
                  '(" " (:eval (abbreviate-file-name (file-name-directory (buffer-file-name)))))))
    ))
