;; -*- lexical-binding: t; -*-

;; Reduce garbage collection frequency, for faster initialization.
(setq gc-cons-threshold 100000000)

;; Custom settings file.
(load (setq custom-file "~/.emacs.d/custom.el"))

;; Load more init files from `~/.emacs.d/init.d/*.el'.
(dolist (file (directory-files "~/.emacs.d/init.d/" t "\\`[^.].*\\.el\\'" nil))
  (load-file file))

;; Host-specific settings (if any).
(let ((host-init-file (format "~/.emacs.d/init.%s.el" (system-name))))
  (when (file-exists-p host-init-file)
    (load-file host-init-file)))
